/********************************************************
 * ZELDA::DRAW.C  **********************************************
 ********************************************************/

#include "internal.h"
const char *text_item (int num){
	int it = pp.items[num];
	switch(it){
		case I_FEU : return "Feu";
		case I_BOTTES : return "Bottes";
		case I_GRAPPIN : return "Grappin";
		case I_BOOMERANG : return "Boomerang";
		case I_BOMBE : return "Bombe";
		case I_FLEURS : return "FleurS";
		case I_GANT : return "Gants";
		case I_EPEE : 
		if(pp.pvfrappe==1) return "Epee";
		else return "EpeeX";
		break;
	}
	return "";
}
////////// makloub //////////
BITMAP *
MAKLOUB (BITMAP * bmp)
{
  BITMAP *s = create_bitmap (bmp->w, bmp->h);
  if(!s) err(MEMORY_ERROR);
  clear_bitmap (s);
  draw_sprite_h_flip (s, bmp, 0, 0);
  return s;
}
////////// makloub 2/////////
BITMAP *
MAKLOUB2 (BITMAP * bmp)
{
  BITMAP *s = create_bitmap (bmp->w, bmp->h);
  if(!s) err(MEMORY_ERROR);
  clear_bitmap (s);
  draw_sprite_v_flip (s, bmp, 0, 0);
  return s;
}

/**************** procedure du Menu ***********************/
int
menu (void)
{
  int i, x, y, m, cx = 20, cy = 35, px = 0, r;
  int angle = 0;
  int mode=0,CY=cy,ech=20,MAX=pp.max_items,av=px,CX=cx,avcx=CX;
   char s[256];
   while(BTENTER) {poll_keyboard();poll_joystick();}
    counter_menu_angle = 0;
 

  while (1)
    {
    
      if(counter_menu_angle >= MENU_ANGLE_DELAY){
	      counter_menu_angle = 0;
	      angle = (angle + MENU_ANGLE_INC) % 256;
      }
      {
	      int im;
	      if(Map.hqst == -1) {
		      if(Map.stage >= 155) im=MENU2;
		      else im=MENU;
	      }
	      else {
		      if(Map.hqst >= 155) im=MENU2;
		      else im=MENU;
	      }
      rotate_scaled_sprite (buffer, Data[im].dat, -150, -100,
			    itofix (angle), itofix (2));
      }

      show_barre (buffer);
      rect (buffer, 0, 30, SCREEN_W - 1, SCREEN_H - 1, 9);
      rect (buffer, 0, 120, SCREEN_W - 1, SCREEN_H - 1, 9);
      my_textout(buffer , sfont , "Sauver  Charger  Quitter",20,CY+130,7,15);
     sprintf(s,"%i cristals",n_crystal);
      my_textout(buffer , sfont , s , 20 , CY+140,12,4);
      if(mode==0) my_textout(buffer,sfont, text_item(px+1) , 20,130,7,15);
      x = 0;
      y = 35;

      for (i = 0; i < max_troc; i++)
	{
	  draw_sprite (buffer, Data[ret_troc (i)].dat, x, y + 40);
	  x += 20;
	}
      x = 0;
      for (i = 1; i < pp.max_items + 1; i++)
	{
	  x += 20;
	  m = pp.items[i];
	  if (m)
	    draw_sprite (buffer, Data[items[m].images[0]].dat, x, y);

	}

      if (BTRIGHT && px + 1 <= (MAX - 1))
	{
	  play_sfx (SFX13);
	  cx += ech;
	  px++;
	  rest (50);
	}
      if (BTLEFT && px - 1 >= 0)
	{
	  play_sfx (SFX13);
	  cx -= ech;
	  px--;
	  rest (50);
	}
	  if(BTUP){
		  	  while(BTUP){poll_keyboard();poll_joystick();}
			  play_sfx (SFX13);
			  cx=avcx;
			  px=av;
			  mode=0;
			  cy=CY;
			  ech=20;
			  MAX=pp.max_items;
	  }
	  else if(BTDOWN){
		  	  while(BTDOWN){poll_keyboard();poll_joystick();}
			  play_sfx (SFX13);
			  av=px;
			  avcx=cx;
			  cx=CX;
			  px=0;
			  mode=1;
			  cy=CY+125;
			  ech=70;
			  MAX=3;
	  }
	  if(mode == 1){
			  if(BTACTION_A || BTACTION_B || BTSPACE){
				  	 play_sfx (SFX15);
					 if(px == 0){
						 const char *P="PARTIE SAUVEGARDEE";
						 char s[256];
						 sprintf(s,"save/slot%i",slot_number);
						 save_game(s);
						 textout(screen ,font,P,(SCREEN_W-(strlen(P)*8))/2,(SCREEN_H-8)/2,0);
						 rest(500);
					 }
					 if(px == 1){
						 const char *P="PARTIE CHARGEE";
						 char s[256];
						 sprintf(s,"save/slot%i",slot_number);
						 load_game(s);
						 textout(screen ,font,P,(SCREEN_W-(strlen(P)*8))/2,(SCREEN_H-8)/2,0);
						 load_all_screen_map();
						 rest(500);
						 Map.place = set_place(Map.stage);
						 play_place_midi(Map.place);
						 fade_out(FADE_NORMAL);
						 setpal;
						 AFFICHE_BLIT();
						 return 0;
					 }
					 if(px == 2){
						 yes_quit=1;
						 return 0;
					 }

			  }
	  }
      draw_sprite (buffer, Data[CHOIX].dat, cx - 20, cy + 5);

      if (BTACTION_A && pp.max_items >= px + 1 && mode == 0)
	{
  	 play_sfx (SFX15);

	  r = pp.item[0];
	  SET_ITEM (0, pp.items[px + 1]);
	  pp.items[px + 1] = r;
	  while(BTACTION_A)  poll_keyboard ();poll_joystick();
	}
      if (BTACTION_B && pp.max_items >= px + 1 && mode == 0)
	{
     	  play_sfx (SFX15);
	  r = pp.item[1];
	  SET_ITEM (1, pp.items[px + 1]);
	  pp.items[px + 1] = r;
	  while(BTACTION_B)  poll_keyboard ();poll_joystick();

	}

      blit (buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
      poll_keyboard ();
	  poll_joystick();	 

      if (BTENTER){
     	  play_sfx (SFX14);
	while(BTENTER) {poll_keyboard();poll_joystick();}
	break;
      }
    }
  rest (100);
}
/************************** affiche la barre en haut de l'ecran *************/
//show_barre
int
show_barre (BITMAP * bmp)
{
  int i, r;
  char c[5];
  if (pp.item[0])
    {
      draw_sprite (bmp, Data[items[pp.item[0]].images[0]].dat, 0, 0);
    }
  if (pp.item[1])
    {
      draw_sprite (bmp, Data[items[pp.item[1]].images[0]].dat, 21, 0);
    }
  {
char ss[20];
  sprintf(ss,"x%i",pp.arg);
  draw_sprite (bmp, Data[DIAM0].dat, 50, 0);
  my_textout (bmp , sfont , ss,70,10,7,15);
  sprintf(ss,"x%i",pp.clef);
  draw_sprite (bmp, Data[CLEF0].dat, 94, 0);
  my_textout (bmp , sfont , ss,110,10,7,15);
  }

  rect (bmp, 0, 0, 20, 20, 1);
  rect (bmp, 1, 1, 19, 19, 9);


  rect (bmp, 20, 0, 40, 20, 1);
  rect (bmp, 21, 1, 39, 19, 9);


  rect (bmp, 130, 0, 130 + (pp.hpmax) * 20, 20, 1);
  rect (bmp, 131, 1, 129 + (pp.hpmax) * 20, 19, 9);

  for (i = 0; i < (pp.hpmax); i++)
    {
      draw_sprite (bmp, Data[VIE2].dat, 130 + (i * 20), 0);
    }

  for (i = 0; i < (pp.hp); i++)
    {
      draw_sprite (bmp, Data[VIE0].dat, 130 + (i * 20), 0);
    }

}

///////////////////////////// affiche //////////////////////////////////
int
affiche (BITMAP * bmp)
{
  int i, c;
  BITMAP *s;
  clear_bitmap (bmp);
  for (i = 0; i < Map.maxlayer + 1; i++){
      show_map (bmp, Map, Map.maxlayer - i);
    }
  
  show_persos (bmp);
  show_monsters (bmp);
  
  if (!SHOW_PERSO)
    return 1;


/* bombe */
  if(obj.cur == I_BOMBE && obj.en){
	  draw_sprite (bmp , Data[items[obj.cur].images[obj.anim]].dat,obj.x,obj.y);
}

  if ( (obj.cur != I_EPEE || !obj.en) || pp.jeter_epee){
	  int t=0;
    t: 
      if(PPSURF && (iseau(pp.obs1) || iseau(pp.obs2))){
	      t=1;
      }
  
      if (pp.dir == 0)
      {
        if(t) ((BITMAP*)(Data[pp.images[pp.anim[0]]].dat))->h = 10;
	draw_sprite (bmp, Data[pp.images[pp.anim[0]]].dat, pp.x, pp.y);

       if(t) ((BITMAP*)(Data[pp.images[pp.anim[0]]].dat))->h = 20;

      }
      
      else if (pp.dir == 1){
         if(t) ((BITMAP*)(Data[pp.images[9+pp.anim[1]]].dat))->h = 10;
	  s = MAKLOUB (Data[pp.images[9 + pp.anim[1]]].dat);
	  draw_sprite (bmp, s, pp.x, pp.y);
	  destroy_bitmap (s);
         if(t) ((BITMAP*)(Data[pp.images[9+pp.anim[1]]].dat))->h = 20;

	}
      
      else if (pp.dir == 2){
	if(t) ((BITMAP*)(Data[pp.images[3+pp.anim[2]]].dat))->h = 10;
	draw_sprite (bmp, Data[pp.images[3 + pp.anim[2]]].dat, pp.x, pp.y);
	if(t) ((BITMAP*)(Data[pp.images[3+pp.anim[2]]].dat))->h = 20;
      }
      
      else if (pp.dir == 3){
        if(t) ((BITMAP*)(Data[pp.images[6+pp.anim[3]]].dat))->h = 10;
	draw_sprite (bmp, Data[pp.images[6 + pp.anim[3]]].dat, pp.x, pp.y);
	if(t) ((BITMAP*)(Data[pp.images[6+pp.anim[3]]].dat))->h = 20;
      }
    }
  
  else{
      if (pp.dir == 0)
	draw_sprite (bmp, Data[pp.images[12 + obj.anim]].dat, pp.x, pp.y);
      
      if (pp.dir == 1){
	  s = MAKLOUB (Data[pp.images[12 + obj.anim]].dat);
	  draw_sprite (bmp, s, pp.x, pp.y);
	  destroy_bitmap (s);
	}
      
      if (pp.dir == 2)
	draw_sprite (bmp, Data[pp.images[14 + obj.anim]].dat, pp.x, pp.y);
      if (pp.dir == 3)
	draw_sprite (bmp, Data[pp.images[16 + obj.anim]].dat, pp.x, pp.y);

    }

/******************************** animation de L'epee ****************/
  //////////// EPEE JETEE
  if (obj.cur == I_EPEE && obj.en){
      int p1x,p1y,p2x,p2y,d1,d2;
      hbs ();

      obj.anim = counter_frappe / 100;
      HBS (obj.x , obj.y , EPEE_VIT , obj.dir,&p1x,&p1y,&p2x,&p2y);
      epee_test (p1x,p1y);
      epee_test (p2x,p2y);
      if (pp.jeter_epee){
	   

	  if (obj.anim >= 1){
		  
	      
	      if (obj.dir == 0){
		  if(counter_frappe2 >= EPEE_DELAY) {obj.x += EPEE_VIT;counter_frappe2=0;}
		  draw_sprite (bmp, Data[items[obj.cur].images[1]].dat, obj.x,
			       obj.y);

	       }	
	      
	      else if (obj.dir == 1){
		  if(counter_frappe2 >= EPEE_DELAY) {obj.x -= EPEE_VIT;counter_frappe2=0;}
		  s = MAKLOUB (Data[items[obj.cur].images[1]].dat);
		  draw_sprite (bmp, s, obj.x, obj.y);
		  destroy_bitmap (s);
		}
	      
	      else if (obj.dir == 2){
		  if(counter_frappe2 >= EPEE_DELAY) {obj.y -= EPEE_VIT;counter_frappe2=0;}
		  draw_sprite (bmp, Data[(items[obj.cur].images[0])].dat,
			       obj.x, obj.y);
		}
	      
	      else if (obj.dir == 3){
		  if(counter_frappe2 >= EPEE_DELAY) {obj.y += EPEE_VIT;counter_frappe2=0;}
		  s = MAKLOUB2 (Data[items[obj.cur].images[0]].dat);
		  draw_sprite (bmp, s, obj.x, obj.y);
		  destroy_bitmap (s);
		}

	      if (obj.x >= SCREEN_W || obj.x <= 0 || obj.y <= 0
		  || obj.y >= SCREEN_H){
		  obj.en = 0;
		  obj.cur = 0;
		  pp.jeter_epee = 0;
		  ep=0;
		  goto endf;
		}
	      

	    }

	}
	  

      ////////////// EPEE NON JETEE
      if (!pp.jeter_epee){

	  if (obj.anim == 1){
		  
		  
	      if (obj.dir == 0){
		  draw_sprite (bmp, Data[items[obj.cur].images[1]].dat,
			       obj.x + 20, obj.y + 2);
		}
	      
	      
	      else if (obj.dir == 1){
		  s = MAKLOUB (Data[items[obj.cur].images[1]].dat);
		  draw_sprite (bmp, s, obj.x - 20, obj.y + 2);
		  destroy_bitmap (s);
		}
	      
	      
	      else if (obj.dir == 2){
		  draw_sprite (bmp, Data[(items[obj.cur].images[0])].dat,
			       obj.x + 5, obj.y - 5);
		}
	      
	      else if (obj.dir == 3){
		  s = MAKLOUB2 (Data[items[obj.cur].images[0]].dat);
		  draw_sprite (bmp, s, obj.x + 5, obj.y + 5);
		  destroy_bitmap (s);
		}
	      
	    }
	
	 if (obj.anim >= 2){
	      obj.cur = 0;
	      obj.en = 0;
	    }

	}
  
      ////////////////////////////////////////////////////////

      if (obj.anim == 0){

	  if (obj.dir == 0)
	    draw_sprite (bmp, Data[items[obj.cur].images[0]].dat, obj.x + 10,
			 obj.y - 10);
	  
	  
	  else if (obj.dir == 1)
	    draw_sprite (bmp, Data[(items[obj.cur].images[0])].dat,
			 obj.x - 10, obj.y - 10);
	  
	  
	  
	  else if (obj.dir == 2){
	      s = MAKLOUB2 (Data[items[obj.cur].images[0]].dat);
	      draw_sprite (bmp, s, obj.x + 10, obj.y + 10);
	      destroy_bitmap (s);
	    }
	  
	  
	  
	  else if (obj.dir == 3)
	    draw_sprite (bmp, Data[(items[obj.cur].images[0])].dat,
			 obj.x + 10, obj.y - 10);
          }
  
   }



endf:

  if (pp.hezz && pp.hezz_obj != -1){
      draw_sprite (bmp, Data[Map.images[pp.hezz_obj]].dat, pp.x, pp.y - 16);
    }

  show_obj (bmp);
  show_barre (bmp);

  if(show_bulle != -1) 
	  draw_sprite (bmp , Data[show_bulle].dat , pp.x+7 , pp.y-7);

  return 0;


}


//////////////////////////////// show_map ///////////////////////////////
int
show_map (BITMAP * bmp, MAP m, int layer)
{
  int xp, yp, d = 0, r, n;
  BITMAP *s = 0, *s2 = 0;
  for (yp = 0; yp < SCREEN_H - 1; yp += 20)
    {
      for (xp = 0; xp < SCREEN_W - 1; xp += 20)
	{

	  if (m.show[layer][d] != 67)
	    {

	      r = m.images[m.show[layer][d]];
	      s = 0;
	      s2 = 0;
	      if (m.makloub[m.show[layer][d]])
		{
		  if (m.makloub[m.show[layer][d]] == 1)
		    s = MAKLOUB (Data[r].dat);
		  if (m.makloub[m.show[layer][d]] == 2)
		    s = MAKLOUB2 (Data[r].dat);
		  if (m.makloub[m.show[layer][d]] == 3)
		    {
		      s2 = MAKLOUB (Data[r].dat);
		      s = MAKLOUB2 (s2);
		    }
		  if (m.makloub[m.show[layer][d]] == 4)
		    {
		      s2 = MAKLOUB2 (Data[r].dat);
		      s = MAKLOUB (s2);
		    }

		}
	      else
		s = Data[r].dat;

	      if (s){
		draw_sprite (bmp, s, xp, yp);
	      }
	      n = m.makloub[m.show[layer][d]];
	      if (n == 1 || n == 2)
		destroy_bitmap (s);
	      if (n == 3 || n == 4)
		{
		  destroy_bitmap (s);
		  destroy_bitmap (s2);
		}

	    }
	  d++;
	}
    }
}



//////////////////////////////// scroll_map ////////////////////////////
int
scroll_map (BITMAP * b1, BITMAP * b2, int dir, int fois, int delay)
{
  int i;
  switch (dir)
    {
    case 0:
      for (i = SCREEN_W; i >= 0; i -= fois)
	{
	  counter = 0;
	  blit (b1, screen, 0, 0, i - SCREEN_W, 0, SCREEN_W, SCREEN_H);
	  blit (b2, screen, 0, 0, i, 0, SCREEN_W, SCREEN_H);
	  while (counter < delay);
	}
      break;
    case 1:
      for (i = 0; i <= SCREEN_W; i += fois)
	{
	  counter = 0;
	  blit (b1, screen, 0, 0, i, 0, SCREEN_W, SCREEN_H);
	  blit (b2, screen, 0, 0, i - SCREEN_W, 0, SCREEN_W, SCREEN_H);
	  while (counter < delay);
	}
      break;
    case 2:
      for (i = 0; i <= SCREEN_H; i += fois)
	{
	  counter = 0;
	  blit (b1, screen, 0, 0, 0, i, SCREEN_W, SCREEN_H);
	  blit (b2, screen, 0, 0, 0, i - SCREEN_H, SCREEN_W, SCREEN_H);
	  while (counter < delay);
	}
      break;

    case 3:
      for (i = SCREEN_H; i >= 0; i -= fois)
	{
	  counter = 0;
	  blit (b1, screen, 0, 0, 0, i - SCREEN_H, SCREEN_W, SCREEN_H);
	  blit (b2, screen, 0, 0, 0, i, SCREEN_W, SCREEN_H);
	  while (counter < delay);
	}
      break;

    }
}
/*************************************************************************/
