/********************************************************
 * ZELDA::UTIL.C  **********************************************
 ********************************************************/

#include "internal.h"
/************************** variables ***********************/
int delay_textanim = 20; /* delay de l'animation du texte */
/* pour MP3 */

#ifndef NO_MP3
MP3FILE *mp3 = 0;        /* structure MP3 */
int ret = 0;            
int MP3_PLAYED;
#endif

/******************* choix **************************/
int im_choix=CHOIX;
int
Choix (int x,int y,int max,int ech,int start ){
	BITMAP *image = Data[im_choix].dat;
	BITMAP *save=create_bitmap(SCREEN_W,SCREEN_H);
	int cxx=start;
	int cx=x,cy=y;
	clear_keybuf();
	rest (200);
	clear_keybuf();

	blit(buffer,save,0,0,0,0,SCREEN_W,SCREEN_H);
	blit(save,buffer,0,0,0,0,SCREEN_W,SCREEN_H);
	draw_sprite (buffer , image , cx , cy);
	BLIT ();

	cy+=(ech * cxx);
	while(1){
		poll_keyboard ();
		poll_joystick ();
		
		if(BTUP){
			play_sfx (SFX13);
			cxx--;
			if(cxx < 0) cxx=max-1;
			cy = y + (ech*cxx);
			rest (CHOIX_DELAY);
			blit(save,buffer,0,0,0,0,SCREEN_W,SCREEN_H);
			draw_sprite (buffer , image , cx , cy);
			BLIT ();
		
		}
		if(BTDOWN){
			play_sfx (SFX13);
			cxx++;
			if(cxx > max-1) cxx=0;
			cy = y + (ech*cxx);
			rest (CHOIX_DELAY);
			blit(save,buffer,0,0,0,0,SCREEN_W,SCREEN_H);
			draw_sprite (buffer , image , cx , cy);
			BLIT ();

		}
		if(BTSPACE){
			play_sfx(SFX15);
			break;
		}
	}
	
	
	if(save) {destroy_bitmap(save);save=NULL;}
	clear_keybuf ();
	rest (200);
	clear_keybuf ();
	return cxx;
}
/***************** play_sfx ************************/

int
play_sfx (int n)
{
  return play_sample (Data[n].dat, 255, 128, 1000, 0);
}

/*********************** textanim *********************/
// si s alors retourne -1
// si espace (pour tout crire) alors retourne 1
// 0 si rien
int
textanim (BITMAP * bmp, FONT * f, char *s, int x, int y, int c1, int c2,
	  int delay, int dejaespace)
{
  int i = 0, r = text_length (f, " ");
  char m[2];
  if (!s) return -1;

  while(BTSPACE) { poll_keyboard(); poll_joystick(); }

  while (*s)
    {
      poll_keyboard();  poll_joystick();
      if(BTSPACE) dejaespace=1;

      sprintf (m, "%c", *s);
      textout (bmp, f, m, x + i, y, c1);
      textout (bmp, f, m, x + i - 1, y - 1, c2);
      i += r;
      s++;

      if(!dejaespace) { 
	      rest (delay);
      	      blit (bmp, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
      
              // il joue le mp3 si pas espace...
              #ifndef NO_MP3
              if(MP3_PLAYED) ret = poll_mp3_file (mp3);
              #endif
      }
    }
  if(dejaespace) {
      	  blit (bmp, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	  return 1;
  }
  return 0;
}
/*********************** draw_parle *********************/
void draw_parle(BITMAP *bmp,int x,int y,int w,int h){
	BITMAP *bit = create_bitmap(w,h);
	clear_to_color (bit,monde() ? 12 :  9);
	draw_trans_sprite(bmp,bit,x,y);
	rect (bmp , x , y , x+w,y+h , 8);
	rect (bmp , x-1 , y-1 , x+w+1,y+h+1 , 15);
	if(bit) {destroy_bitmap(bit);bit=NULL;}
}

void draw_parle_anim 
(BITMAP *b,BITMAP *save,int x,int y,int w,int h,int max,int delay){
	
   int dx , dy , dw=0 , dh=0;
   int dwp,dhp,i;
   dwp = w / max;
   dhp = h / max;
   for(i = 0 ; i < max ; i++){  
	  dw +=  dwp;
	  dh +=  dhp;
	  dx = (w - dw) / 2;
	  dy = ((h - dh) / 2) + y;
	  blit(save,b,0,0,0,0,SCREEN_W,SCREEN_H);
	  draw_parle (b ,  dx,dy , dw ,dh);
	  BLIT ();
	  rest (delay);
  }

}
/*************************** parle *****************************/
int
parle (char *s, char *s2, char *s3, char *index)
{
  char c[256];
  int i;
  int x = 0  , y = 150; 
  int dejaespace=0;
 
  BITMAP *bit=create_bitmap(SCREEN_W,150);
  BITMAP *save=0;
  
  if(!bit) return -1;
  save = create_bitmap(SCREEN_W,SCREEN_H);
  if(!save) return -1;
  
  blit(buffer,save,0,0,0,0,SCREEN_W,SCREEN_H);
  draw_parle_anim (buffer,save,x,y,SCREEN_W,50,20,20); 
  
  #ifndef NO_MP3
  MP3_PLAYED = 0;
  
  if (index)
    {
      sprintf (c, "patches/mp3/%s.mp3", index);
      if (exists (c) && SOUND_DETECTED == 0)
	{
	  mp3 = open_mp3_file (c);
	  if (mp3 )
	    {
	      MP3_PLAYED = 1;
	      if (play_mp3_file (mp3, BUFSZ, 255, 128) != ALMP3_OK)
		MP3_PLAYED = 0;
	    }
	  if (MP3_PLAYED)
	    set_volume (-1, 50);

	}
    }
  #endif
  {
  char *S[3] = {s,s2,s3}; 
  int i;
  //affiche le texte anim !
  for(i=0;i<3;i++) {
  if(textanim (buffer, Data[SMALL_FONT].dat, S[i], 4, (y+10)+i*(2+text_height(Data[SMALL_FONT].dat)), 8, 15, delay_textanim, dejaespace)==1){
	  //ferme le mp3
  	  #ifndef NO_MP3
	  if(MP3_PLAYED) {
	  	  MP3_PLAYED=0;
	          set_volume (-1, MIDI_VOLUME);
        	  close_mp3_file (mp3);
	  }
          #endif
	  //et indique que c espace pour les autres messages !
	  dejaespace=1;
  }
  } //endfor

  if(dejaespace) {
    while (!BTSPACE){ poll_keyboard (); poll_joystick(); }
  }

  }
  #ifndef NO_MP3
  if(MP3_PLAYED && !dejaespace){
	  while (poll_mp3_file (mp3) == ALMP3_OK);
  }
  #endif
  //atends qu'il lache la touche espace...
  if(dejaespace) while(BTSPACE) {poll_keyboard();poll_joystick();}
  while (!BTSPACE){ poll_keyboard (); poll_joystick(); }

  
  if(dejaespace){
	  while (BTSPACE){ poll_keyboard (); poll_joystick(); }
  }
  while (BTSPACE){ poll_keyboard (); poll_joystick(); }

  blit(save , buffer , 0,0,0,0,SCREEN_W,SCREEN_H);

  #ifndef NO_MP3
  if (MP3_PLAYED)
    {
      close_mp3_file (mp3);
      set_volume (-1, MIDI_VOLUME);
      MP3_PLAYED = 0;
    }
  #endif

  if(bit) {destroy_bitmap(bit);bit=0;}
  if(save) {destroy_bitmap(save);save=0;}
}

/********************** INC *******************/
int
INC (int j, int w, int *x, int *y)
{
  switch (j)
    {
    case 0:
      break;
    case 1:
      *x = *x + w;
      break;
    case 2:
      *y = *y + w;

      break;
    case 3:
      *x = *x + w;
      *y = *y + w;
      break;
    }
}

/***************************** Explosion *************************/		
int
Explosion (BITMAP *sprite,int x, int y, int max)
{
  int e;
  BITMAP *save;
  save = create_bitmap(SCREEN_W,SCREEN_H);
  if(!save) return -1;
  blit(buffer , save,0,0,0,0,SCREEN_W,SCREEN_H);
  
  for (e = 0; e < max; e++)
    {
	  blit(save , buffer , 0,0,0,0,SCREEN_W,SCREEN_H);
      stretch_sprite (buffer, sprite, x, y, 20 + e, 20 + e);
      blit (buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
      rest (10);
    }
	  blit(save , buffer , 0,0,0,0,SCREEN_W,SCREEN_H);

   if(save) {destroy_bitmap(save);save=0;}
}


/***************************** explosion *************************/		
int
explosion (int x, int y, int max)
{
	Explosion (Data[EXPL0].dat,x,y,max);
}

// fonction tres utile , j'ai fait avec le Boomerang

/************************** EQUATION_DROITE_X_TO_Y ****************/
int EQUATION_DROITE_X_TO_Y(int x,int xa,int ya,int xb,int yb){
		return  (((yb - ya) * x) - ((xa * yb) + (xb * ya))) / (xb - xa);
}

/************************ EQUATION_DROITE_Y_TO_X *****************/
int EQUATION_DROITE_Y_TO_X(int y,int xa,int ya,int xb,int yb){
		return  (((xa - xb) * y) - ((xa * yb) +( ya * xb))) / (ya - yb);
}

/************************ swapvar ***********************/
int swapvar(int *p1,int *p2){
		int s=*p2;
		*p2 = *p1;
		*p1 = s;
}

/************************* input ***************/
int input (const char *d1,const char *d2){
	int x=0,y=150;
	int col=15;
	FONT *f=Data[SMALL_FONT].dat;
	draw_parle (buffer , x,y ,SCREEN_W-1,48);
	if(d1) textout (buffer , f , d1,x+25,y+2 , col);
	if(d2) textout (buffer , f , d2,x+25,y+10, col);
	return Choix(x+5,y+2,2,text_height(f),0);

}

/************************ yesno ***************************/

int
yesno () {return input("oui","non");}

/************************ coll *****************************/
int
coll (int x1,int y1,int w1,int h1,int x2,int y2,int w2,int h2){
	return (!( ((x1)>=(x2)+(w2)) || ((x2)>=(x1)+(w1)) || ((y1)>=(y2)+(h2)) || ((y2)>=(y1)+(h1)) ));
}

/************************ teleport **************************/
void teleport (int max,int t,int col,int delay){
	int i;

	for(i = 0 ; i < max ; i++){
		int x,y;
		x = rand () % SCREEN_W;y  = rand() % SCREEN_H;
		line (buffer , x , y  , x + t , y + t , col);
		BLIT ();
		rest (delay);
	}
}

void Tih (BITMAP *buf ,BITMAP *bmp , int yp , int ymax , int c,int del){
  int y;	
  for(y = yp ; y <= ymax ; y++){
	  clear_to_color (buf,c);
	  draw_sprite (buf , bmp,(SCREEN_W-bmp->w)/2,y);
	  BLIT();
	  rest (del);
  }

}
char* select_name (BITMAP *b , char *t,int x,int y,int col){
	char text [256]={0},n=0;
	BITMAP *save;
	if(t) {
		strcpy(text, t);
		n=strlen(t);
	}
	save=create_bitmap(SCREEN_W,SCREEN_H);
	blit(b,save,0,0,0,0,SCREEN_W,SCREEN_H);
		blit(save,b,0,0,0,0,SCREEN_W,SCREEN_H);
		textout (b,font,"|",x+(n*text_length(font," ")),y,col);
		textout (b,font,text,x,y,col);
		
		blit(b,screen,0,0,0,0,SCREEN_W,SCREEN_H);

	
	while (!key[KEY_ENTER]){
		int c;
		if(keypressed()){
			c=readkey()&0xff;
			if(c == 8 && n>=1){
				text[n-1]=0;
				n--;
		blit(save,b,0,0,0,0,SCREEN_W,SCREEN_H);
		textout (b,font,"|",x+(n*text_length(font," ")),y,col);
		textout (b,font,text,x,y,col);
		
		blit(b,screen,0,0,0,0,SCREEN_W,SCREEN_H);

			}

			if(isalpha(c)){
				text[n]=c;
				text[n+1]=0;
				n++;
		blit(save,b,0,0,0,0,SCREEN_W,SCREEN_H);
		textout (b,font,"|",x+(n*text_length(font," ")),y,col);
		textout (b,font,text,x,y,col);
		
		blit(b,screen,0,0,0,0,SCREEN_W,SCREEN_H);

			}
		}
	}
	destroy_bitmap(save);
	return strdup(text);
}
void frapper_perso (int num){
int k;
int dir=notdir(pp.dir);
counter_anim=0;

for (k = 0; k < 100; k++){
     ANIMATION();
     
     if(counter_anim >= ANIM_DELAY){
	     marcher (dir);
	     pp.anim[dir]++;
	     counter_anim = 0;
     }
     if(pp.anim[dir] >= 3){
	     pp.anim[dir]=0;
	     counter_anim=0;
     }
     affiche (buffer);
     blit (buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
}
pp.hp-=num;
if(pp.hp<0) {
	pp.hp=0;
}

}

void my_textout (BITMAP *b , FONT *f , const char *s , int x,int y, int c1,int c2){	
	textout(b,f,s,x,y,c1);
	textout(b,f,s,x-1,y-1,c2);

}
void pres_text (char *text){ 
	  FONT *f = Data[SMALL_FONT].dat;
	  int w = text_length(f,text);
	  int h = text_height(f);
	  textanim (buffer , f , text , (SCREEN_W-w)/2 , (SCREEN_H-h)/2 , 0 ,15,delay_textanim,0);
	  while (BTSPACE) {poll_keyboard ();poll_joystick();}
	  counter=0;
	  while (!BTSPACE) {if(counter>=3000) break;poll_keyboard ();poll_joystick();}
	  clear_bitmap(buffer);
}
